/*
 * Copyright 1991 Addison-Wesley Publishing Company
 *                (see the file "COPYRIGHTS" for details)
 */

#include <Xm/Xm.h>
#include <X11/Protocols.h>

#define     STAY_UP      "\"Stay Up\"     f.send_msg 4417"
#define     XA_STAY_UP   (Atom)4417

#define XA_MOTIF_WM_MESSAGES XmInternAtom (XtDisplay(message_box),   \
                                           "_MOTIF_WM_MESSAGES", False)
#define XA_WM_DELETE_WINDOW  XmInternAtom (XtDisplay(message_box),   \
                                           "WM_DELETE_WINDOW", True)
#define XA_WM_PROTOCOLS      XmInternAtom (XtDisplay(message_box),   \
                                           "WM_PROTOCOLS", True)

static void DoUnmanage (message_box, client_data, call_data)
    Widget      message_box;
    caddr_t     client_data;
    caddr_t     call_data;
{
    XtUnmanageChild (message_box);
}

static void ReactivateEntry (w, client_data, call_data)
    Widget      w;   /* either message box or shell */
    caddr_t     client_data;
    caddr_t     call_data;
{
    Widget      message_box = (Widget) client_data,
                shell = XtParent (message_box);

    XtAddCallback (message_box, XmNokCallback, DoUnmanage, NULL);

    XmActivateProtocol (shell, XA_MOTIF_WM_MESSAGES, XA_STAY_UP);
    XtRemoveCallback (message_box, XmNcancelCallback, 
                                    ReactivateEntry, (caddr_t) message_box);
    XmRemoveProtocolCallback (shell, XA_WM_PROTOCOLS, XA_WM_DELETE_WINDOW,
                                    ReactivateEntry, (caddr_t) message_box);
}
    
static void StayUp (w, client_data, call_data)
    Widget      w;
    caddr_t     client_data;
    caddr_t     call_data;
{
    Widget      message_box = (Widget) client_data,
                shell = XtParent (message_box);

    XtRemoveCallback (message_box, XmNokCallback, DoUnmanage, NULL);

    XmDeactivateProtocol (shell, XA_MOTIF_WM_MESSAGES, XA_STAY_UP);
    XtAddCallback (message_box, XmNcancelCallback, 
                                 ReactivateEntry, (caddr_t) message_box);
    XmAddProtocolCallback (shell, XA_WM_PROTOCOLS, XA_WM_DELETE_WINDOW,
                                 ReactivateEntry, (caddr_t) message_box);
}

void MakeDialogStayUp (message_box)
    Widget      message_box;
{
    Arg         args[2];
    Widget      shell = XtParent (message_box);
    Atom        wm_messages = XA_MOTIF_WM_MESSAGES;

    XtSetArg (args[0], XmNmwmMenu, STAY_UP);
    XtSetArg (args[1], XmNdeleteResponse, XmUNMAP);
    XtSetValues (shell, args, 2);

    XtAddCallback (message_box, XmNokCallback, DoUnmanage, NULL);
    XtAddCallback (message_box, XmNcancelCallback, DoUnmanage, NULL);
    XmAddProtocolCallback (shell, XA_MOTIF_WM_MESSAGES, XA_STAY_UP,
                           StayUp, (caddr_t) message_box);
    XmAddProtocols (shell, XA_WM_PROTOCOLS, &wm_messages, 1);
}
